<?php
 
class Functions {
 
  private $db;
	private $conn;
	
  //Change the username and password to your own.
  private $username = "admin";
  private $password = "pass";
 	
  // constructor
  function __construct() {
      require_once 'Database.php';
      // connecting to database
      $this->db = new Database();
      $this->conn =  $this->db->connect();
  }
	
	public function closeDatabase(){
		 mysqli_close($this->conn);
	}
	
    //database functions__________________________________________________________________________________

    //add new image to database
    public function newImage($imageurl, $smallimageurl) {
        $imageurl= mysqli_real_escape_string($this->conn,$imageurl);
        $result = mysqli_query($this->conn,"INSERT INTO images(imageurl, smallimageurl) VALUES('$imageurl', '$smallimageurl')");
        // check for successful store
        if ($result) {
            return true;
        } else {
            return false;
        }
    }
    
    //delete a images with id
    public function DeleteImage($id) {
        $result = mysqli_query($this->conn,"DELETE FROM images WHERE id='$id'");
        // check for successful store
        if ($result) {
            return true;
        } else {
            return false;
        }
    }
    

    //Return all images from database
    public function displayImages() {
        $result = mysqli_query($this->conn,"SELECT id, imageurl, smallimageurl from images");
        // check for successful store
        if ($result) {
            $records = array();
            while ($row = mysqli_fetch_assoc($result)){
                $records[] = $row;
            }
            return $records;
        } else {
            return false;
        }
    }

    //add new song to database
    public function newSong($lirics, $title, $imageurl, $soundurl) {
        $lirics= mysqli_real_escape_string($this->conn,$lirics);
        $title= mysqli_real_escape_string($this->conn,$title);
        $imageurl= mysqli_real_escape_string($this->conn,$imageurl);
        $soundurl= mysqli_real_escape_string($this->conn,$soundurl);

        $result = mysqli_query($this->conn,"INSERT INTO songs(lirics, title, imageurl, soundurl) VALUES('$lirics', '$title', '$imageurl', '$soundurl')");
        // check for successful store
        if ($result) {
            return true;
        } else {
            return false;
        }
    }

    //update a song already in database
    public function updateSong($id ,$lirics, $title, $imageurl, $soundurl) {
        $id= mysqli_real_escape_string($this->conn,$id);
        $lirics= mysqli_real_escape_string($this->conn,$lirics);
        $title= mysqli_real_escape_string($this->conn,$title);
        $imageurl= mysqli_real_escape_string($this->conn,$imageurl);
        $soundurl= mysqli_real_escape_string($this->conn,$soundurl);



        if(strlen($imageurl)>2)
          $imageurl = ", imageurl = '$imageurl'";
        else
          $imageurl = "";

        if(strlen($soundurl)>2)
          $soundurl = ", soundurl = '$soundurl'";
        else
          $soundurl = "";

        $result = mysqli_query($this->conn,"UPDATE songs SET title='$title', lirics='$lirics' ".$soundurl.$imageurl." WHERE id='$id'");

        // check for successful store
        if ($result) {
            return true;
        } else {
            return false;
        }
    }
    
    //delete a song with id
    public function DeleteSong($id) {
        $result = mysqli_query($this->conn,"DELETE FROM songs WHERE id='$id'");
        // check for successful store
        if ($result) {
            return true;
        } else {
            return false;
        }
    }
    

    //Return all songs from database
    public function displaySongs() {
        $result = mysqli_query($this->conn,"SELECT id, lirics, title, imageurl, soundurl from songs");
        // check for successful store
        if ($result) {
            $records = array();
            while ($row = mysqli_fetch_assoc($result)){
                $records[] = $row;
            }
            return $records;
        } else {
            return false;
        }
    }

     //add new news to database
    public function newNews($title, $news) {
        $title= mysqli_real_escape_string($this->conn,$title);
        $news= mysqli_real_escape_string($this->conn,$news);
        $result = mysqli_query($this->conn,"INSERT INTO news(title, news) VALUES('$title', '$news')");
        // check for successful store
        if ($result) {
            return true;
        } else {
            return false;
        }
    }

    //update a news already in database
    public function updateNews($id, $title, $news) {
        $id= mysqli_real_escape_string($this->conn,$id);
        $title= mysqli_real_escape_string($this->conn,$title);
        $news= mysqli_real_escape_string($this->conn,$news);
        $result = mysqli_query($this->conn,"UPDATE news SET title='$title', news='$news' WHERE id='$id'");
        // check for successful store
        if ($result) {
            return true;
        } else {
            return false;
        }
    }
    
    //delete a news with id
    public function DeleteNews($id) {
        $result = mysqli_query($this->conn,"DELETE FROM news WHERE id='$id'");
        // check for successful store
        if ($result) {
            return true;
        } else {
            return false;
        }
    }
    

    //Return all songs from database
    public function displayNews() {
        $result = mysqli_query($this->conn,"SELECT id, title, news from news ORDER BY time");
        // check for successful store
        if ($result) {
            $records = array();
            while ($row = mysqli_fetch_assoc($result)){
                $records[] = $row;
            }
            return $records;
        } else {
            return false;
        }
    }



    //login functions______________________________________________________________________________________________________
    public function Login()
    {
        //login if password and username correct
        if(!empty($_POST['login']))
        {
            if(empty($_POST['username']))
            {
              echo("<p class='error'>UserName is empty!</p>");
              return false;
            }
             
            if(empty($_POST['password']))
            {
                echo("<p class='error'>Password is empty!</p>");
              return false;
            }
             
            $user = trim($_POST['username']);
            $pass = trim($_POST['password']);
             
            if(($pass != $this->password) || ($user != $this->username))
            {
            	echo("<p class='error'>Incorrect Username or Password</p>");
                return false;
            }
             
            $_SESSION[$this->username] = $user;
            return true;
        }
    }
    //logout
    public function logout()
    {
        if(empty($_GET['logout']))
        {
            return false;
        }
        if(trim($_GET['logout']) == "logout")
        {
            unset($_SESSION[$this->username]);
            return true;
        }
        else
        {
            return false;
        }
    }
    
    //checks if user is logged in
    public function isLoggedIn()
    {
         if(isset($_SESSION[$this->username]))
         {
            return true;
         }
         return false;
    }
    
    //returns the current user logged in
    public function user()
    {
         return $_SESSION[$this->username];
    }
    
    //displays the login form
    public function loginform(){
            echo(
            "<form id='login' action='index.php' method='post' accept-charset='UTF-8'>
                  <h2>Login</h2>
                   <p><input type='hidden' name='login' value='1'/></p>
                   <p><label for='username' >UserName</label></p>
                   <p><input type='text' name='username' id='username'  maxlength='50' /></p>
                   <p><label for='password' >Password</label></p>
                   <p><input type='password' name='password' id='password' maxlength='50' /></p>
                  <button type='submit' name='Submit'>Submit</button>
              </form>");
    }

    //Editor function____________________________________________________________________________________________________________
    //displays an editor for the songs
    public function song_editor($id, $title, $lirics, $imageurl, $soundurl){
        echo("<div class='editor-overlay'>".
                "<div class='editor'>".
                    "<img class='close-editor' src='images/close.png' alt='close'>".

                    "<form class='edit-form' action='processpost.php' method='post' accept-charset='UTF-8' enctype='multipart/form-data'>
                          <h2>Edit Song</h2>
                          <input type='hidden' name='tag' value='edit-song'/>
                          <input type='hidden' name='id' class='id' value='".$id."'/>
                          <div class='edit-row'>
                              <h3>Title</h3>
                              <p>The title that would be displayed in the list.</p>
                              <p><input type='text' name='title'  value='".$title."' /></p>
                          </div>
                          <div class='edit-row'>
                              <h3>Lirics</h3>
                              <p>Enter the Song lirics.</p>
                              <p><textarea type='text' name='lirics'  />".$lirics."</textarea></p>
                          </div>
                          <div class='edit-row'>
                              <h3>Upload an image to the server</h3>
                              <p>Accepted formats: .gif, .png, .jpeg, .jpg. Max file size: 1MB.</p>
                              <p><label for='file'>Filename:</label></p>
                              <p><input type='file' name='file' id='file'><br></p>
                              <p>Current Image Url: ".$imageurl."</p>
                          </div>
                          <div class='edit-row'>
                              <h3>Upload an Audio file to the server</h3>
                              <p>Accepted formats: .MP3 Max file size: 10MB.</p>
                              <p><label for='soundfile'>Filename:</label></p>
                              <p><input type='file' name='soundfile' id='soundfile'><br></p>
                              <p>Current Sound Url: ".$soundurl."</p>
                          </div>
                          <p><button type='submit' name='Submit'>Save</button></p>
                      </form>".
                "</div>".
            "</div><!--close ed-overlay-->");
    }
    //displays an editor for the news
    public function news_editor($id, $title, $news){
        echo("<div class='editor-overlay'>".
                "<div class='editor'>".
                    "<img class='close-editor' src='images/close.png' alt='close'>".
                    "<form class='edit-form' action='processpost.php' method='post' accept-charset='UTF-8' enctype='multipart/form-data'>
                          <h2>Edit News</h2>
                          <input type='hidden' name='tag' value='edit-news'/>
                          <input type='hidden' name='id' class='id' value='".$id."'/>
                          <div class='edit-row'>
                              <h3>Title</h3>
                              <p>The title that would be displayed in the list.</p>
                              <p><input type='text' name='title'  value='".$title."' /></p>
                          </div>
                          <div class='edit-row'>
                              <h3>News</h3>
                              <p>Enter the News.</p>
                              <p><textarea type='text' name='news'  />".$news."</textarea></p>
                          </div>
                          <p><button type='submit' name='Submit'>Save</button></p>
                    </form>".
                "</div>".
            "</div>");
    }

    public function getSmallImage($imageurl){
      $imageurl = basename($imageurl);
      $ext = pathinfo("upload/" . $imageurl, PATHINFO_EXTENSION);
      return (str_replace('.'.$ext, '', "upload/" . $imageurl).'_small.'.$ext);
    }


}
 
?>