<?php
	 require_once 'Functions.php';
	 $functions = new Functions();
	 session_start();
	 
	 //continue only if user is logged in
	 if(!$functions->isLoggedIn()){
		 exit;
	 }

	 function create_thumbnail($file, $destination, $t_width = 150, $t_height = 150){
		$image_source =			getimagesize($file);	
		$source_mime = 			$image_source['mime'];
		$source_x = 			$image_source[0];
		$source_y = 			$image_source[1];
		
		if($source_mime == "image/png"){
			$image = imagecreatefrompng($file);
		}else if($source_mime == "image/jpeg"){
			$image = imagecreatefromjpeg($file);
		}else if($source_mime == "image/gif"){
			$image = imagecreatefromgif($file);
		}
		
		
		$ratio = 			$t_width / $source_x;
		$t_height = 		$source_y * $ratio;
		$export_image = 	imagecreatetruecolor($t_width, $t_height);
		
		imagecopyresized($export_image, $image, 0, 0, 0, 0, $t_width, $t_height, $source_x, $source_y);

		switch($source_mime)  
	    {  
	        case "image/jpg":  
	        case "image/jpeg":  
	            if (imagetypes() & IMG_JPG) { 
	            	clearstatcache();
	                imagejpeg($export_image, $destination, 100);  
	            }  
	            break;  
	  
	        case "image/gif":  
	            if (imagetypes() & IMG_GIF) {  
	            	clearstatcache();
	                imagegif($export_image, $destination);  
	            }  
	            break;  
	  
	        case "image/png":  
	  
	            if (imagetypes() & IMG_PNG) {  
	            	clearstatcache();
	                imagepng($export_image, $destination, 0);  
	            }  
	            break;  
	  
	        default:  
	            // *** No extension - No save.  
	            break;  
	    }  
		
		return $destination;
	}

	 function uploadimage($_FILES, $create_small){
	  	$imageurl = "";
		if (!empty($_FILES['file']['name'])) {
			$allowedExts = array("gif", "jpeg", "jpg", "png");
			$extension = end(explode(".", $_FILES["file"]["name"]));
			if ((($_FILES["file"]["type"] == "image/gif")|| ($_FILES["file"]["type"] == "image/jpeg")|| ($_FILES["file"]["type"] == "image/jpg")|| ($_FILES["file"]["type"] == "image/png"))&& ($_FILES["file"]["size"] < 1060000)&& in_array($extension, $allowedExts))
			{
				if ($_FILES["file"]["error"] > 0)
				{
					echo "Error: " . $_FILES["file"]["error"];
				}
				else
				{
					if(move_uploaded_file($_FILES["file"]["tmp_name"],"upload/" . $_FILES["file"]["name"])){
						$imageurl = "http://".$_SERVER["HTTP_HOST"].dirname($_SERVER['REQUEST_URI'])."/upload/" . $_FILES["file"]["name"];
						if($create_small){
							//create small image file
							$functions = new Functions();
							$smallimageurl = $functions->getSmallImage($_FILES["file"]["name"]);
							create_thumbnail($imageurl, $smallimageurl, 150, 150);
						}
					}
					else
						echo "Please create a directory named 'upload' in: "."http://".$_SERVER["HTTP_HOST"].dirname($_SERVER['REQUEST_URI'])."/";
						
				
				}
			}
			else
			{
				echo "Image file larger than 1MB or not a supported format. Please try again.";
			}
		}

		return $imageurl;
	 }

	 function uploadsound($_FILES){
	 	$soundurl = "";

	 	$fileName = $_FILES['soundfile']['name'];
	    $tmpName = $_FILES['soundfile']['tmp_name'];
	    $fileSize = $_FILES['soundfile']['size'];
	    $fileType = $_FILES['soundfile']['type'];

		if ($fileType != 'audio/mpeg' && $fileType != 'audio/mpeg3' && $fileType != 'audio/mp3' && $fileType != 'audio/x-mpeg' && $fileType != 'audio/x-mp3' && $fileType != 'audio/x-mpeg3' && $fileType != 'audio/x-mpg' && $fileType != 'audio/x-mpegaudio' && $fileType != 'audio/x-mpeg-3') {
		        echo('The file is not an MP3 file.');
		    } else if ($fileSize > 10485760) {
		        echo('File should not be more than 10mb');
		    } else {
			    	if ($_FILES["soundfile"]["error"] > 0){
						echo "Error: " . $_FILES["soundfile"]["error"];
					}
					else{
						if(move_uploaded_file($tmpName,"upload/" . $fileName)){
							$soundurl = "http://".$_SERVER["HTTP_HOST"].dirname($_SERVER['REQUEST_URI'])."/upload/" . $fileName;
						}
						else
							echo "Please create a directory named 'upload' in: "."http://".$_SERVER["HTTP_HOST"].dirname($_SERVER['REQUEST_URI'])."/";
					}
	 		}
	 	
	 	return $soundurl;
	 }

	 
	 //check for tags and process delete and edit
	 if(!empty($_POST['tag']))
	 {
		
		//process image
		if($_POST['tag'] == "add-image")
		{
			
			$imageurl = uploadimage($_FILES, true);
			
			$functions->newImage($imageurl, "http://".$_SERVER['HTTP_HOST'].dirname($_SERVER['REQUEST_URI'])."/".($functions->getSmallImage($imageurl)));
		}
		
		if($_POST['tag'] == "delete-image")
		{
			$images = $functions->displayImages();

			foreach($images as $key => $image){
				if($image['id'] == $_POST['id']){
					unlink( "upload/".basename($image["imageurl"]));
					unlink( $functions->getSmallImage($image["imageurl"]) );
				}
				
			}

			
			$functions->deleteImage($_POST['id']);
		}

		//process song
		if($_POST['tag'] == "edit-song")
		{
		
			$imageurl = uploadimage($_FILES, false);
			$soundurl = uploadsound($_FILES);
			
			if($_POST['id'] == 0)
				$functions->newSong($_POST['lirics'],$_POST['title'],$imageurl, $soundurl);
			else
				$functions->updateSong($_POST['id'], $_POST['lirics'],$_POST['title'],$imageurl, $soundurl);
		}
		
		if($_POST['tag'] == "delete-song")
		{

			$songs = $functions->displaySongs();

			foreach($songs as $key => $song){
				if($song['id'] == $_POST['id']){
					unlink( "upload/".basename($song["imageurl"]));
				}
				
			}

			$functions->deleteSong($_POST['id']);
		}

		//process song
		if($_POST['tag'] == "edit-news")
		{
			if($_POST['id'] == 0)
				$functions->newNews($_POST['title'],$_POST['news']);
			else
				$functions->updateNews($_POST['id'], $_POST['title'], $_POST['news']);
		}
		
		if($_POST['tag'] == "delete-news")
		{
			$functions->deleteNews($_POST['id']);
		}

		 header('Location: index.php');
		
		
	 }
?>